using System.IO;
using UnrealBuildTool;

public class LandOfBarl : ModuleRules {
	private void AddRustLibrary(ReadOnlyTargetRules Target) {
		var CrateDir = Path.Combine(ModuleDirectory, "..", "land_of_barl");
		
		var TargetName = "release";
		
		var LibraryPath = "";
		if (Target.Platform == UnrealTargetPlatform.Win64) {
			LibraryPath = Path.Combine(CrateDir, "target", TargetName, "land_of_barl.lib");
			
			PublicSystemLibraries.Add("Bcrypt.Lib");
			PublicSystemLibraries.Add("Ntdll.Lib");
			PublicSystemLibraries.Add("Userenv.Lib");
			PublicSystemLibraries.Add("WSock32.Lib");
			PublicSystemLibraries.Add("WS2_32.Lib");
		} else if (Target.Platform == UnrealTargetPlatform.Mac || Target.Platform == UnrealTargetPlatform.Linux) {
			LibraryPath = Path.Combine(CrateDir, "target", TargetName, "libland_of_barl.a");
		}

		ExternalDependencies.Add(LibraryPath);
		PublicAdditionalLibraries.Add(LibraryPath);
	}

	public LandOfBarl(ReadOnlyTargetRules Target) : base(Target) {
		PCHUsage = PCHUsageMode.UseExplicitOrSharedPCHs;
	
		PublicDependencyModuleNames.AddRange(new string[] { "Core", "CoreUObject", "Engine", "InputCore", "EnhancedInput" });

		PrivateDependencyModuleNames.AddRange(new string[] { });
		
		AddRustLibrary(Target);
	}
}